Index: /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE.env
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE.env	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/arch/arch-X64_IRENE.env	(revision 1875)
@@ -7,2 +7,4 @@
 module load blitz
 module load feature/bridge/heterogenous_mpmd
+
+module load totalview
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/bld.cfg
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/bld.cfg	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/bld.cfg	(revision 1875)
@@ -38,4 +38,6 @@
 src::xios::transformation::Functions    $PWD/src/transformation/Functions
 src::xios::type                         $PWD/src/type
+src::xios::manager                      $PWD/src/manager
+
 
 src::netcdf $PWD/extern/netcdf4
@@ -46,4 +48,5 @@
 #bld::target test_remap.exe
 bld::target xios_server.exe 
+bld::target generic_testcase.exe 
 #bld::target test_regular.exe
 #bld::target test_xios2_cmip6.exe
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/make_xios
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/make_xios	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/make_xios	(revision 1875)
@@ -11,4 +11,5 @@
 use_extern_blitz="false"
 use_memtrack="false"
+use_tv="false"
 job="1"
 netcdf_lib="netcdf4_par"
@@ -34,9 +35,10 @@
 	    echo "       [--full] : to generate dependencies and recompile from scratch"
 	    echo "       [--use_oasis 'oasis3' 'oasis3_mct' : default oasis3_mct] : to use Oasis coupler"
-        echo "       [--build_path : absolute path to the build directory"
-        echo "       [--build_dir : name of the build directory"
-        echo "       [--build_suffixed : generate automatically suffixed name of the build directory (e.g. config_X64_CURIE_prod)"
-        echo "       [--use_extern_boost : to use external boost library"
-        echo "       [--use_extern_blitz : to use external blitz library"
+        echo "       [--build_path] : absolute path to the build directory"
+        echo "       [--build_dir ]: name of the build directory"
+        echo "       [--build_suffixed ]: generate automatically suffixed name of the build directory (e.g. config_X64_CURIE_prod)"
+        echo "       [--use_extern_boost] : to use external boost library"
+        echo "       [--use_extern_blitz] : to use external blitz library"
+        echo "       [--use_tv] : to use totalview data type display"
 	    echo "       [--doc] : to generate Doxygen documentation (not available yet)"
 	    echo "       [--job ntasks] : to use parallel compilation with ntasks"
@@ -59,4 +61,5 @@
          "--use_extern_boost")  use_extern_boost="true" ; shift  ;;
          "--use_extern_blitz")  use_extern_blitz="true" ; shift  ;;
+         "--use_tv")  use_tv="true" ; shift  ;;
          "--doc")   doc="true"          ; shift ;;
          "--job")   job=$2              ; shift ; shift ;;
@@ -233,4 +236,9 @@
 fi
 
+if [[ "$use_tv" == "true" ]]
+then
+   echo "src::tv_data_display $PWD/extern/tv_data_display" >> ${PWD}/bld_dir.cfg
+fi
+
 
 if [[ "$use_memtrack" == "true" ]]
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.cpp	(revision 1875)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.cpp	(revision 1875)
@@ -0,0 +1,8 @@
+#include "array_new.hpp"
+
+namespace xios
+{
+
+
+}
+
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/array_new.hpp	(revision 1875)
@@ -7,8 +7,25 @@
 #include "buffer_out.hpp"
 #include "message.hpp"
+#include "tv_data_display.h"
+#ifdef __GNUC__
+#include <typeinfo>
+#include <cxxabi.h>
+#endif
 #include <cmath>
 
 using namespace blitz;
 BZ_DECLARE_FUNCTION(round)
+
+namespace xios
+{
+  template <typename T_numtype,int N_rank>
+  class CArray ;
+
+ template <typename T_numtype,int N_rank>
+ int TV_ttf_display_type ( const CArray<T_numtype, N_rank>* array ) ;
+}
+
+template <typename T_numtype,int N_rank>
+int TV_ttf_display_type ( const xios::CArray<T_numtype, N_rank>* array ) ;
 
 namespace xios
@@ -19,5 +36,8 @@
     private:
       bool initialized;
-
+      void inc_symbol(void)
+      {
+        TV_ttf_display_type(this);
+      }
     public:
       typedef typename Array<T_numtype,N_rank>::T_default_storage T_default_storage;
@@ -27,45 +47,45 @@
         : Array<T_numtype,N_rank>(expr)
         , initialized(true)
-      {}
+      { bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol(); }
 
       CArray(GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(storage)
         , initialized(false)
-      {}
+      { bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       explicit CArray(int length0, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, length1, storage)
         , initialized(true)
-      {}
+      { bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, length1, length2, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, length1, length2, length3, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0,length1, length2, length3, length4, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, int length5, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, int length5, int length6, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, length6, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, int length5, int length6, int length7,
@@ -73,5 +93,5 @@
         : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, length6, length7, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, int length5, int length6,
@@ -79,5 +99,5 @@
        : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, length6, length7, length8, storage)
        , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4,
@@ -85,5 +105,5 @@
         : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, length6, length7, length8, length9, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(int length0, int length1, int length2, int length3, int length4, int length5, int length6,
@@ -91,10 +111,10 @@
        : Array<T_numtype,N_rank>(length0, length1, length2, length3, length4, length5, length6, length7, length8, length9, length10, storage)
        , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(T_numtype* restrict dataFirst, TinyVector<int, N_rank> shape, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(dataFirst, shape, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(T_numtype* restrict dataFirst, TinyVector<int, N_rank> shape, TinyVector<diffType, N_rank> stride,
@@ -102,5 +122,5 @@
         : Array<T_numtype,N_rank>(dataFirst, shape, stride, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(T_numtype* restrict dataFirst, TinyVector<int, N_rank> shape, preexistingMemoryPolicy deletionPolicy,
@@ -108,5 +128,5 @@
         : Array<T_numtype,N_rank>(dataFirst, shape, deletionPolicy, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(T_numtype* restrict dataFirst, TinyVector<int, N_rank> shape, TinyVector<diffType, N_rank> stride,
@@ -114,10 +134,10 @@
         : Array<T_numtype,N_rank>(dataFirst, shape, stride, deletionPolicy, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(const TinyVector<int, N_rank>& extent, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(extent, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(const TinyVector<int, N_rank>& lbounds, const TinyVector<int, N_rank>& extent,
@@ -125,35 +145,35 @@
         : Array<T_numtype,N_rank>(lbounds, extent, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, r1, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, r1, r2, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5, GeneralArrayStorage<N_rank> storage = T_default_storage())
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5, Range r6,
@@ -161,5 +181,5 @@
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, r6, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5, Range r6, Range r7,
@@ -167,5 +187,5 @@
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, r6, r7, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5,
@@ -173,5 +193,5 @@
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, r6, r7, r8, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5,
@@ -179,5 +199,5 @@
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Range r0, Range r1, Range r2, Range r3, Range r4, Range r5, Range r6, Range r7,
@@ -185,40 +205,40 @@
         : Array<T_numtype,N_rank>(r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(const CArray<T_numtype, N_rank>& array)
         : Array<T_numtype,N_rank>(array)
         , initialized(array.initialized)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(const Array<T_numtype, N_rank>& array)
         : Array<T_numtype,N_rank>(array)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(const TinyVector<int,N_rank-1>& shape, int lastExtent, const GeneralArrayStorage<N_rank>& storage)
         : Array<T_numtype,N_rank>(shape, lastExtent, storage)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0)
         : Array<T_numtype,N_rank>(array, r0)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1)
         : Array<T_numtype,N_rank>(array, r0, r1)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2)
         : Array<T_numtype,N_rank>( array, r0, r1, r2)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3)
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2,
@@ -226,5 +246,5 @@
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3,  r4)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2,
@@ -232,5 +252,5 @@
         : Array<T_numtype,N_rank>( array, r0, r1, r2, r3, r4, r5)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3,
@@ -238,5 +258,5 @@
         : Array<T_numtype,N_rank>( array, r0, r1, r2, r3, r4, r5, r6)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3, Range r4,
@@ -244,5 +264,5 @@
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3, r4, r5, r6, r7)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3, Range r4, Range r5,
@@ -250,5 +270,5 @@
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3, r4, r5, r6, r7, r8)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3, Range r4, Range r5,
@@ -256,5 +276,5 @@
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3, r4, r5, r6, r7, r8, r9)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, Range r0, Range r1, Range r2, Range r3, Range r4, Range r5, Range r6,
@@ -262,15 +282,15 @@
         : Array<T_numtype,N_rank>(array, r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, const RectDomain<N_rank>& subdomain)
         : Array<T_numtype,N_rank>(array, subdomain)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       CArray(Array<T_numtype, N_rank>& array, const StridedDomain<N_rank>& subdomain)
         : Array<T_numtype,N_rank>(array, subdomain)
         , initialized(true)
-      {}
+      {bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol();}
 
       template<int N_rank2, typename R0, typename R1, typename R2, typename R3, typename R4, typename R5,
@@ -279,5 +299,5 @@
         : Array<T_numtype,N_rank>(array, r0,r1, r2, r3, r4, r5, r6, r7, r8, r9, r10)
         , initialized(true)
-      {}
+      { bool neverTrue ; neverTrue=false ; bool neverTrue ; neverTrue=false ; if(neverTrue) inc_symbol(); }
 
       virtual ~CArray() {}
@@ -548,5 +568,46 @@
       virtual size_t size(void) const { return size(this->numElements()); }
       static size_t size(sizeType numElements) { return (N_rank + 1) * sizeof(int) + sizeof(size_t) + numElements * sizeof(T_numtype); }
-
+      
+      static int show_TV_ttf_display_type ( const CArray<T_numtype,N_rank>* array )
+      {
+        int status ;
+        if (array->isEmpty()) 
+        {
+          status = TV_ttf_add_row("State", TV_ttf_type_ascii_string,"(empty)") ;
+          if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+          else return TV_ttf_format_ok_elide ;
+        }
+        else 
+        {
+          char tname[128] ;
+          char bname[128] = "value_type" ;
+#ifdef __GNUC__
+         size_t size = sizeof(bname) ;
+         abi::__cxa_demangle(typeid(T_numtype).name(), bname, &size, &status) ;
+         if (status !=0) return TV_ttf_format_raw ;
+#endif
+          int dim = array->dimensions() ;
+          if (dim==1) snprintf (tname, sizeof(tname), "%s[%d]", bname, array->extent(0));
+          if (dim==2) snprintf (tname, sizeof(tname), "%s[%d][%d]", bname, array->extent(1), array->extent(0));
+          if (dim==3) snprintf (tname, sizeof(tname), "%s[%d][%d][%d]", bname, array->extent(2), array->extent(1), array->extent(3));
+          if (dim==4) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d]", bname, array->extent(0), array->extent(1), array->extent(2), array->extent(3));
+          if (dim==5) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d]", bname, array->extent(4), array->extent(3), array->extent(2), array->extent(1)
+                                                                                      ,array->extent(0));
+          if (dim==6) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d][%d]", bname, array->extent(5), array->extent(4), array->extent(3), array->extent(2)
+                                                                                      ,array->extent(1),array->extent(0));
+          if (dim==7) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d][%d][%d]", bname, array->extent(6), array->extent(5), array->extent(4), array->extent(3)
+                                                                                      ,array->extent(2),array->extent(1),array->extent(0));
+          status = TV_ttf_add_row("array_values", tname, array->dataFirst()) ;
+          if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+          else return TV_ttf_format_ok ;
+        }
+      }
+      
+
+      static int TV_ttf_display_type ( const CArray<T_numtype,N_rank>* array )
+      {
+        return show_TV_ttf_display_type (array) ;
+      }
+      
       virtual CBaseType* clone(void) const { return new CArray(*this); }
 
@@ -578,5 +639,33 @@
         return ret;
       }
+
   };
+
+
+#define macrotyperank(_TYPE_,_RANK_)\
+  template<> int CArray<_TYPE_,_RANK_>::TV_ttf_display_type( const CArray<_TYPE_,_RANK_>* array ) \
+  {\
+    return show_TV_ttf_display_type (array) ;\
+  }
+
+#define macrotype(_TYPE_)\
+macrotyperank(_TYPE_,1)\
+macrotyperank(_TYPE_,2)\
+macrotyperank(_TYPE_,3)\
+macrotyperank(_TYPE_,4)\
+macrotyperank(_TYPE_,5)\
+macrotyperank(_TYPE_,6)\
+macrotyperank(_TYPE_,7)
+
+macrotype(double)
+macrotype(int)
+macrotype(bool)
+macrotype(size_t)
+macrotype(float)
+macrotype(string)
+
+#undef macrotyperank
+#undef macrotype
+
 
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array.hpp	(revision 1875)
@@ -21,6 +21,5 @@
       {
         public :
-
-           using CArray<T_numtype,N_rank>::operator = ;
+            using CArray<T_numtype,N_rank>::operator = ;
 
             /// Constructeurs ///
@@ -65,4 +64,45 @@
             virtual void generateFortranInterfaceGetBody_(ostream& oss,const string& className) ;
             virtual void generateFortranInterfaceGetDeclaration(ostream& oss,const string& className) ;
+ 
+ static int show_TV_ttf_display_type ( const CAttributeArray<T_numtype,N_rank>* array )
+      {
+        int status ;
+        if (array->isEmpty()) 
+        {
+          status = TV_ttf_add_row("State", TV_ttf_type_ascii_string,"(empty)") ;
+          if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+          else return TV_ttf_format_ok_elide ;
+        }
+        else 
+        {
+          char tname[128] ;
+          char bname[128] = "value_type" ;
+#ifdef __GNUC__
+         size_t size = sizeof(bname) ;
+         abi::__cxa_demangle(typeid(T_numtype).name(), bname, &size, &status) ;
+         if (status !=0) return TV_ttf_format_raw ;
+#endif
+          int dim = array->dimensions() ;
+          if (dim==1) snprintf (tname, sizeof(tname), "%s[%d]", bname, array->extent(0));
+          if (dim==2) snprintf (tname, sizeof(tname), "%s[%d][%d]", bname, array->extent(1), array->extent(0));
+          if (dim==3) snprintf (tname, sizeof(tname), "%s[%d][%d][%d]", bname, array->extent(2), array->extent(1), array->extent(3));
+          if (dim==4) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d]", bname, array->extent(0), array->extent(1), array->extent(2), array->extent(3));
+          if (dim==5) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d]", bname, array->extent(4), array->extent(3), array->extent(2), array->extent(1)
+                                                                                      ,array->extent(0));
+          if (dim==6) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d][%d]", bname, array->extent(5), array->extent(4), array->extent(3), array->extent(2)
+                                                                                      ,array->extent(1),array->extent(0));
+          if (dim==7) snprintf (tname, sizeof(tname), "%s[%d][%d][%d][%d][%d][%d][%d]", bname, array->extent(6), array->extent(5), array->extent(4), array->extent(3)
+                                                                                      ,array->extent(2),array->extent(1),array->extent(0));
+          status = TV_ttf_add_row("array_values", tname, array->dataFirst()) ;
+          if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+          else return TV_ttf_format_ok ;
+        }
+      }
+      
+            
+            static int TV_ttf_display_type ( const  CAttributeArray<T_numtype,N_rank>* array )
+           {
+             return CAttributeArray<T_numtype,N_rank>::show_TV_ttf_display_type (array) ;
+           }
 
          private :
@@ -75,4 +115,30 @@
           bool _fromBuffer(CBufferIn& buffer) ;
       }; // class CAttributeEnum
+
+
+#define macrotyperank(_TYPE_,_RANK_)\
+  template<> int CAttributeArray<_TYPE_,_RANK_>::TV_ttf_display_type(const CAttributeArray<_TYPE_,_RANK_>* array ) \
+  {\
+    return CAttributeArray<_TYPE_,_RANK_>::show_TV_ttf_display_type (array) ;\
+  }
+
+#define macrotype(_TYPE_)\
+macrotyperank(_TYPE_,1)\
+macrotyperank(_TYPE_,2)\
+macrotyperank(_TYPE_,3)\
+macrotyperank(_TYPE_,4)\
+macrotyperank(_TYPE_,5)\
+macrotyperank(_TYPE_,6)\
+macrotyperank(_TYPE_,7)
+
+macrotype(double)
+macrotype(int)
+macrotype(bool)
+macrotype(size_t)
+macrotype(float)
+macrotype(string)
+
+#undef macrotyperank
+#undef macrotype
 } // namespace xios
 
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array_impl.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array_impl.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_array_impl.hpp	(revision 1875)
@@ -14,5 +14,5 @@
       CAttributeArray<T_numtype, N_rank>::CAttributeArray(const StdString & id)
          : CAttribute(id)
-      { /* Ne rien faire de plus */ }
+      { bool alwaysFalse ; alwaysFalse=false ; if (alwaysFalse) TV_ttf_display_type(this); }
 
       template <typename T_numtype, int N_rank>
@@ -20,4 +20,5 @@
          : CAttribute(id)
       {
+         bool alwaysFalse ; alwaysFalse=false ; if (alwaysFalse) TV_ttf_display_type(this);
          this->setValue(value);
       }
@@ -27,4 +28,5 @@
          : CAttribute(id)
       {
+         bool alwaysFalse ; alwaysFalse=false ; if (alwaysFalse) TV_ttf_display_type(this);
          umap.insert(umap.end(), std::make_pair(id, this));
       }
@@ -35,4 +37,5 @@
          : CAttribute(id)
       {
+         bool alwaysFalse ; alwaysFalse=false ; if (alwaysFalse) TV_ttf_display_type(this);
          this->setValue(value);
          umap.insert(umap.end(), std::make_pair(id, this));
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_template.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_template.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/attribute_template.hpp	(revision 1875)
@@ -12,4 +12,10 @@
 #include "buffer_out.hpp"
 #include "type.hpp"
+#include "tv_data_display.h"
+
+#ifdef __GNUC__
+#include <typeinfo>
+#include <cxxabi.h>
+#endif
 
 namespace xios
@@ -20,5 +26,5 @@
     The class implements attribute of some basic types
   */
-      template <class T>
+       template <class T>
          class CAttributeTemplate : public CAttribute, public CType<T>
       {
@@ -91,4 +97,36 @@
 //            virtual void generateFortranInterfaceIsDefinedDeclaration(ostream& oss,const string& className) ;
 
+           static int show_TV_ttf_display_type ( const CAttributeTemplate<T>* attr)
+           {
+             int status ;
+             if (attr->isEmpty()) 
+             {
+               status = TV_ttf_add_row("State", TV_ttf_type_ascii_string,"(empty)") ;
+               if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+               else return TV_ttf_format_ok_elide ;
+             }
+             else 
+             {
+               char tname[128] ;
+               char bname[128] = "ValueType" ;
+#ifdef __GNUC__
+               size_t size = sizeof(bname) ;
+               abi::__cxa_demangle(typeid(T).name(), bname, &size, &status) ;
+               if (status !=0) return TV_ttf_format_raw ;
+#endif
+               snprintf (tname, sizeof(tname), "%s", bname);
+               if (typeid(T)==typeid(string))
+                 status = TV_ttf_add_row("values", TV_ttf_type_ascii_string, ((string*)(attr->ptrValue))->c_str() );
+               else status = TV_ttf_add_row("values", tname, attr->ptrValue) ;
+               if (status != TV_ttf_ec_ok) return TV_ttf_format_raw ;
+               else return TV_ttf_format_ok_elide ;
+             }
+           }
+      
+           static int TV_ttf_display_type ( const CAttributeTemplate<T>* attr )
+           {
+             return show_TV_ttf_display_type (attr) ;
+           }
+
 
          protected :
@@ -107,6 +145,20 @@
       }; // class CAttribute
 
+#define macrotype(_TYPE_)\
+  template<> int CAttributeTemplate<_TYPE_>::TV_ttf_display_type( const CAttributeTemplate<_TYPE_>* attr ) \
+  {\
+    return show_TV_ttf_display_type (attr) ;\
+  }
+
+macrotype(double)
+macrotype(int)
+macrotype(bool)
+macrotype(string)
+//macrotype(CDate)
+//macrotype(CDuration)
+#undef macrotype
 
    template <class T>  void FromBinary(StdIStream & is, T & obj);
+
 
 } // namespace xios
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_decl.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_decl.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/buffer_decl.cpp	(revision 1875)
@@ -17,7 +17,9 @@
   macro(short)
   macro(long)
+  macro(longlong)
   macro(uint)
   macro(ushort)
   macro(ulong)
+  macro(ulonglong)
   macro(float)
   macro(double)
